﻿<%@ Page Title="" Language="C#" MasterPageFile="~/Site.master" AutoEventWireup="true"
    CodeFile="Default.aspx.cs" Inherits="Default" %>

<%@ Register Assembly="Infragistics4.Web.v11.2, Version=11.2.20112.1019, Culture=neutral, PublicKeyToken=7dd5c3163f2cd0cb"
    Namespace="Infragistics.Web.UI.EditorControls" TagPrefix="ig" %>
<%@ Register Assembly="Infragistics4.Web.v11.2, Version=11.2.20112.1019, Culture=neutral, PublicKeyToken=7dd5c3163f2cd0cb"
    Namespace="Infragistics.Web.UI" TagPrefix="ig" %>
<%@ Register Assembly="Infragistics4.Web.v11.2, Version=11.2.20112.1019, Culture=neutral, PublicKeyToken=7dd5c3163f2cd0cb"
    Namespace="Infragistics.Web.UI.GridControls" TagPrefix="ig" %>
<%@ Register Assembly="Infragistics4.Web.v11.2, Version=11.2.20112.1019, Culture=neutral, PublicKeyToken=7dd5c3163f2cd0cb"
    Namespace="Infragistics.Web.UI.DataSourceControls" TagPrefix="ig" %>
<asp:Content ID="HeaderContent" runat="server" ContentPlaceHolderID="HeadContent">
</asp:Content>
<asp:Content ID="BodyContent" runat="server" ContentPlaceHolderID="MainContent">
    <script type="text/javascript">
        //Globals
        var currentRow;
        var currParent;
        var currKeys;
        //

        //Set UI
        function SetControls() {

            jQuery("#confParent").button({
                icons: {
                    secondary: "ui-icon-disk"
                }
            });

            jQuery("#newParent").button({
                icons: {
                    secondary: "ui-icon-plus"
                }
            }).click(function () {
                $("#addParent").dialog("option", "title", 'New parent').dialog("open");
                return false;
            });

            jQuery("#edParent").button({
                icons: {
                    secondary: "ui-icon-pencil"
                }
            }).click(function () {
                $('#editParentRow').dialog('option', 'title', 'Edit Parent Row').dialog('open');
                return false;
            });

           
            jQuery("#delParent").button({
                icons: {
                    secondary: "ui-icon-trash"
                }
            }).click(function () {
                if (confirm('Confirm deletion?')) {
                    var grid = $find('<%= whdg.ClientID %>');
                    var gridRows = grid.get_gridView().get_rows();

                    //var rowToDel = gridRows.get_rowFromKey(currentRow.get_dataKey());
                    //gridRows.remove(rowToDel);

                    /* My code */

                    var selection = grid.get_gridView().get_behaviors().get_selection();
                    var selectedRows = selection.get_selectedRowsResolved();

                    for (var i = 0; i < selectedRows.length; i++) {
                        var row = selectedRows[i];
                        var containerGrid = row.get_grid();
                        var gridRows = containerGrid.get_rows();
                        gridRows.remove(row);
                    }               

                    jQuery("#edParent").button('disable');
                    jQuery("#delParent").button('disable');
                    jQuery("#newChild").button('disable');
                    jQuery("#edChild").button('disable');
                    jQuery("#delChild").button('disable');
                    return false;
                }
                return false;
            });

            jQuery("#newChild").button({
                icons: {
                    secondary: "ui-icon-plus"
                }
            }).click(function () {
                jQuery('#addChildRow').dialog("option", "title", 'New child').dialog("open");
                return false;
            });

            jQuery("#edChild").button({
                icons: {
                    secondary: "ui-icon-pencil"
                }
            });

            jQuery("#delChild").button({
                icons: {
                    secondary: "ui-icon-trash"
                }
            }).click(function () {
                if (confirm('Confirm deletion?')) {

                    var grid = $find('<%= whdg.ClientID %>');
                    var gridRows = grid.get_gridView().get_rows().get_row(currentRow.get_grid().get_parentRow().get_index()).get_rowIslands()[0].get_rows();

                    var rowToDel = gridRows.get_rowFromKey(currentRow.get_dataKey());
                    gridRows.remove(rowToDel);

                    jQuery("#edParent").button('disable');
                    jQuery("#delParent").button('disable');
                    jQuery("#newChild").button('disable');
                    jQuery("#edChild").button('disable');
                    jQuery("#delChild").button('disable');
                    return false;
                }
                return false;
            });
        }
        //

        //Startup function
        jQuery(function () {

            SetControls();
            jQuery("#edParent").button('disable');
            jQuery("#delParent").button('disable');
            jQuery("#newChild").button('disable');
            jQuery("#edChild").button('disable');
            jQuery("#delChild").button('disable');

            //$("#editParentRow:ui-dialog").dialog("destroy");

            $("#editParentRow").dialog({
                autoOpen: false,
                height: 400,
                width: 600,
                modal: true,
                buttons: {
                    'Save': function () {
                        var bValid = true;
                        if (bValid) {

                            var grid = $find('<%= whdg.ClientID %>');
                            var rows = grid.get_gridView().get_rows();

                            var f1 = $('#<%= TextBox4.ClientID %>').val();
                            var f2 = $('#<%= TextBox5.ClientID %>').val();
                            var f3 = $('#<%= TextBox6.ClientID %>').val();

                            //Update the cells
                            currentRow.get_cellByColumnKey('pField1').set_value(f1);
                            currentRow.get_cellByColumnKey('pField2').set_value(f2);
                            currentRow.get_cellByColumnKey('pField3').set_value(f3);

                            jQuery("#edParent").button('disable');
                            jQuery("#delParent").button('disable');
                            jQuery("#newChild").button('disable');
                            jQuery("#edChild").button('disable');
                            jQuery("#delChild").button('disable');


                            $(this).dialog("close");
                        }
                    },
                    'Close': function () {
                        $(this).dialog("close");
                    }
                }
            });

            $("#addParent").dialog({
                autoOpen: false,
                height: 400,
                width: 600,
                modal: true,
                buttons: {
                    'Save': function () {
                        var bValid = true;
                        if (bValid) {
                            var grid = $find('<%= whdg.ClientID %>');
                            var rows = grid.get_gridView().get_rows();

                            var f1 = $('#<%= TextBox1.ClientID %>').val();
                            var f2 = $('#<%= TextBox2.ClientID %>').val();
                            var f3 = $('#<%= TextBox3.ClientID %>').val();

                            var prt = [f1, f2, f3];
                            rows.add(prt);
                            $(this).dialog("close");
                        }
                    },
                    'Close': function () {
                        $(this).dialog("close");
                    }
                }
            });

            $("#addChildRow").dialog({
                autoOpen: false,
                height: 400,
                width: 600,
                modal: true,
                buttons: {
                    'Save': function () {
                        var bValid = true;
                        if (bValid) {
                            var chiavi = currParent.get_dataKey();
                            var parID = chiavi[0];
                            var f1 = $('#<%= TextBoxc1.ClientID %>').val();
                            var f2 = $('#<%= TextBoxc2.ClientID %>').val();
                            var f3 = $('#<%= TextBoxc3.ClientID %>').val();

                            var chi = [parID, , f1, f2, f3];

                            // The line below works only if parent row is expanded.
                            // If parent row has no children (just addedd) doesn't work
                            currParent.get_rowIslands()[0].get_rows().add(chi);
                            return false;
                        }
                    },
                    'Close': function () {
                        $(this).dialog("close");
                    }
                }
            });

        });
        //Fine Startup function

        function whdg_rowSelectionChanged(sender, eventArgs) {
            if (eventArgs.getSelectedRows().get_length() == 0) {
                currentRow = null;
                currKeys = null;
                currParent = null;
                return;
            }

            currentRow = eventArgs.getSelectedRows().getItem(0);
            currKeys = currentRow.get_dataKey();
            if (sender.get_band().get_key() == "odsParents_DefaultView") {
                jQuery("#edParent").button('enable');
                jQuery("#delParent").button('enable');
                jQuery("#newChild").button('enable');
                jQuery("#edChild").button('disable');
                jQuery("#delChild").button('disable');
                currParent = currentRow;
            }
            else {
                jQuery("#edParent").button('enable');
                jQuery("#delParent").button('enable');
                jQuery("#newChild").button('enable');
                jQuery("#edChild").button('enable');
                jQuery("#delChild").button('enable');
                currParent = currentRow.get_grid().get_parentRow();
            }
        }

        function editParentRow() {
            $("#editParentRow").dialog("open");
        }
    </script>
    <h2>
        Welcome to ASP.NET!
    </h2>
    <p>
        To learn more about ASP.NET visit <a href="http://www.asp.net" title="ASP.NET Website">
            www.asp.net</a>.
    </p>
    <ig:WebScriptManager ID="WebScriptManager1" runat="server" EnableScriptGlobalization="true"
        EnableScriptLocalization="true" EnablePageMethods="true">
    </ig:WebScriptManager>
    <span id="toolbar" style="padding: 10px 4px;" class="ui-widget-header ui-corner-all">
        <button id="newParent">
            Add parent</button>
        <button id="edParent">
            Edit parent</button>
        <button id="delParent">
            Delete parent</button>&nbsp;&nbsp; <span id="tlbRow">
                <button id="newChild">
                    Add child</button>
                <button id="edChild">
                    Edit child</button>
                <button id="delChild">
                    Delete child</button>
            </span></span>
<%--    <asp:UpdatePanel runat="server" ID="updPanToElab" ClientIDMode="Static" ChildrenAsTriggers="False"
        UpdateMode="Conditional">
        <ContentTemplate>--%>
            <ig:WebHierarchicalDataGrid ID="whdg" runat="server" Height="350px" 
        Width="100%" InitialDataBindDepth=1
                AutoGenerateColumns="False" DataKeyFields="ID" DataSourceID="whds" 
        ondatafiltered="whdg_DataFiltered">
                <Columns>
                    <ig:BoundDataField DataFieldName="pField1" Header-Text="Header 1" Key="pField1">
                        <Header Text="Header 1"></Header>
                    </ig:BoundDataField>
                    <ig:BoundDataField DataFieldName="pField2" Header-Text="Header 2" Key="pField2">
                        <Header Text="Header 2"></Header>
                    </ig:BoundDataField>
                    <ig:BoundDataField DataFieldName="pField3" Header-Text="Header 3" Key="pField3">
                        <Header Text="Header 3"></Header>
                    </ig:BoundDataField>
                </Columns>
                <Bands>
                    <ig:Band AutoGenerateColumns="false" DataKeyFields="ID,rowNum" DataMember="odsChild_DefaultView">
                        <Columns>
                            <ig:BoundDataField DataFieldName="ID" Key="ID" Hidden="true">
                            </ig:BoundDataField>
                            <ig:BoundDataField DataFieldName="rowNum" Header-Text="Row" Key="rigord">
                                <Header Text="Row" />
                            </ig:BoundDataField>
                            <ig:BoundDataField DataFieldName="cField1" Header-Text="Header 1" Key="cField1">
                                <Header Text="Header 1"></Header>
                            </ig:BoundDataField>
                            <ig:BoundDataField DataFieldName="cField2" Header-Text="Header 2" Key="cField2">
                                <Header Text="Header 2"></Header>
                            </ig:BoundDataField>
                            <ig:BoundDataField DataFieldName="cField3" Header-Text="Header 3" Key="cField3">
                                <Header Text="Header 3"></Header>
                            </ig:BoundDataField>
                        </Columns>
                        <Behaviors>
                            <ig:EditingCore Enabled="true">
                                <Behaviors>
                                    <ig:RowDeleting Enabled="true" />
                                    <ig:RowAdding Enabled="true" AddNewRowCssClass="hideAddNewRowBehavior"/>                                                                           
                                </Behaviors>
                            </ig:EditingCore>
                        </Behaviors>
                    </ig:Band>
                </Bands>
                <Behaviors>
                    <ig:EditingCore Enabled="true" EnableInheritance="true">
                        <EditingClientEvents />
                    </ig:EditingCore>
                    <ig:Sorting SortingMode="Multi">
                    </ig:Sorting>
                    <ig:Filtering>
                    </ig:Filtering>
                    <ig:Activation ActiveCellCssClass="activeCellClass" Enabled="true" />
                    <ig:Selection CellClickAction="Row" RowSelectType="Single" Enabled="true" SelectionClientEvents-RowSelectionChanged="whdg_rowSelectionChanged">
                    </ig:Selection>
                </Behaviors>
            </ig:WebHierarchicalDataGrid>
            <ig:WebHierarchicalDataSource ID="whds" runat="server">
                <DataViews>
                    <ig:DataView ID="odsParents_DefaultView" DataMember="DefaultView" DataSourceID="odsParents" />
                    <ig:DataView ID="odsChild_DefaultView" DataMember="DefaultView" DataSourceID="odsChild" />
                </DataViews>
                <DataRelations>
                    <ig:DataRelation ParentColumns="ID" ChildColumns="ID" ParentDataViewID="odsParents_DefaultView"
                        ChildDataViewID="odsChild_DefaultView" />
                </DataRelations>
            </ig:WebHierarchicalDataSource>
            <asp:ObjectDataSource ID="odsParents" runat="server" SelectMethod="LoadParents" TypeName="igWhdgTest.Parents"
                DeleteMethod="DeleteParent" OnInserting="odsParents_Inserting" OnObjectCreating="odsParents_ObjectCreating"
                InsertMethod="AddParent">
                <DeleteParameters>
                    <asp:Parameter Name="ID" Type="Int32" />
                </DeleteParameters>
                <InsertParameters>
                    <asp:Parameter Name="pField1" Type="String" />
                    <asp:Parameter Name="pField2" Type="String" />
                    <asp:Parameter Name="pField3" Type="String" />
                </InsertParameters>
            </asp:ObjectDataSource>
            <asp:ObjectDataSource ID="odsChild" runat="server" OldValuesParameterFormatString="{0}"
                SelectMethod="LoadChildren" DeleteMethod="DeleteChild" OnObjectCreating="odsChild_ObjectCreating"
                TypeName="igWhdgTest.Children" InsertMethod="AddRowChild" OnInserting="odsChild_Inserting">
 
                <DeleteParameters>
                    <asp:Parameter DbType="Int32" Name="ID" DefaultValue="0" />
                    <asp:Parameter DbType="Int32" Name="rowNum" DefaultValue="0" />
                </DeleteParameters>
                <InsertParameters>
                    <asp:Parameter Name="ID" Type="Int32" />
                    <asp:Parameter Name="cField1" Type="String" />
                    <asp:Parameter Name="cField2" Type="String" />
                    <asp:Parameter Name="cField3" Type="String" />
                </InsertParameters>
            </asp:ObjectDataSource>
   <%--     </ContentTemplate>
    </asp:UpdatePanel>--%>
   
    <div id="addParent" title="New parent">
        <fieldset id="fldSetTestata">
            <div style="float: left">
                <div>
                    Field 1:<br />
                    <asp:TextBox ID="TextBox1" runat="server"></asp:TextBox>
                </div>
                <div>
                    Field 2:<br />
                    <asp:TextBox ID="TextBox2" runat="server"></asp:TextBox>
                </div>
                <div>
                    Field 3:<br />
                    <asp:TextBox ID="TextBox3" runat="server"></asp:TextBox>
                </div>
            </div>
        </fieldset>
    </div>
    <div id="addChildRow" title="New child">
        <fieldset id="fldSetRow">
            <div style="float: left">
                <div>
                    cField 1:<br />
                    <asp:TextBox ID="TextBoxc1" runat="server"></asp:TextBox>
                </div>
                <div>
                    cField 2:<br />
                    <asp:TextBox ID="TextBoxc2" runat="server"></asp:TextBox>
                </div>
                <div>
                    cField 3:<br />
                    <asp:TextBox ID="TextBoxc3" runat="server"></asp:TextBox>
                </div>
            </div>
        </fieldset>
    </div>
    <div id="editParentRow" title="Edit Parent">
        <fieldset id="Fieldset1">
            <div style="float: left">
                <div>
                    cField 1:<br />
                    <asp:TextBox ID="TextBox4" runat="server"></asp:TextBox>
                </div>
                <div>
                    cField 2:<br />
                    <asp:TextBox ID="TextBox5" runat="server"></asp:TextBox>
                </div>
                <div>
                    cField 3:<br />
                    <asp:TextBox ID="TextBox6" runat="server"></asp:TextBox>
                </div>
            </div>
        </fieldset>
    </div>

</asp:Content>
